<!DOCTYPE html>
<html lang="en">
  <head>
    <title>Task 520 post lists</title>
    <meta charset="utf-8" />
    <meta name="viewport" content="width=device-width, initial-scale=1" />
    <link
      rel="stylesheet"
      href="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/css/bootstrap.min.css"
    />
    <script src="https://ajax.googleapis.com/ajax/libs/jquery/3.5.1/jquery.min.js"></script>
    <script src="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/js/bootstrap.min.js"></script>
  </head>
  <body>
    <div class="container">
      <div class="text-center my-4">
        <h3 class="text-info">
          <span class="text-danger">Danh sách</span> các bình luận (comment) của
          bài viết
        </h3>
      </div>
      <div class="row form-group">
        <div class="col-sm-2">
          <label class="form-control border border-0 text-dark">
            Điền post id:
          </label>
        </div>
        <div class="col-sm-6">
          <input
            type="text"
            class="form-control"
            id="inp-comment-id"
            placeholder="…điền post id, ví dụ 2, 3 …."
          />
        </div>
        <div class="col-sm-4">
          <button class="btn btn-info form-control" id="btn-get-comment-posts">
            Lấy danh sách bình luận của bài viết
          </button>
        </div>
      </div>
      <table
        class="table table-bordered table-striped table-hover"
        id="tbl-comment-posts"
      >
        <thead class="text-center">
          <tr>
            <th>id</th>
            <th>Post id</th>
            <th>Email</th>
            <th>Name</th>
            <th>Body</th>
            <th>Action</th>
          </tr>
        </thead>
        <tbody>
          <tr>
            <td>1</td>
            <td>1</td>
            <td>huvo@gmail.com</td>
            <td>My name is huvo.</td>
            <td>
              I'm a recluse, the world doesn't know me, but I really understand
              very well.
            </td>
            <td>Action</td>
          </tr>
          <tr>
            <td>2</td>
            <td>1</td>
            <td>dreamaces@gmail.com</td>
            <td>My name is Dream Aces.</td>
            <td>
              I am aces of world so when you need, you can call with me. I will
              carry you on my shoulders.
            </td>
            <td>Action</td>
          </tr>
        </tbody>
      </table>
    </div>
    <script>
      "use strict";

      /*** REGION 1 - Global variables - Vùng khai báo hằng số, tham số TOÀN CỤC */
      const gCOL_POSTID = 0;
      const gCOL_POSTTITLE = 1;
      const gCOL_POSTBODY = 2;
      const gCOL_ACTION = 3;
      const gBASE_URL = "https://jsonplaceholder.typicode.com";

      var vInputCommentId = $("#inp-comment-id");

      /*** REGION 2 - Vùng gán / thực thi sự kiện cho các elements */
      $(document).ready(function () {
        //gán event handler cho nút
        $("#btn-get-comment-posts").click(onBtnGetCommentByPostsIdClick);
      });

      /*** REGION 3 - Event handlers - Vùng khai báo các hàm xử lý sự kiện */
      // hàm xử lý sự kiện lấy post của người dùng (4 bước xử lý)
      function onBtnGetCommentByPostsIdClick() {
        "use strict";
        var vCommentIdObj = { commmentId: 0 };
        //b1: thu thập dữ liệu
        readData(vCommentIdObj);
        //kiểm tra dữ liệu
        var vIsCheck = validateCommentId(vCommentIdObj);
        if (vIsCheck) {
          //3. gọi server
          callSeverByGetAjax(vCommentIdObj);
        }
      }

      //hàm xử lý sự kiện click button detail
      function onBtnDetailClick(paramEventClick) {
        "use strict";
        console.log(
          "%cDetail button click. Sự kiện Click là: ....",
          "color:orange"
        );
        var vButtonBiAn = paramEventClick.currentTarget;
        const vFORM_TO_OPEN = "task 520 Post Detail.html"; //đây là form sẽ mở
        var vUrlToOpenPage =
          vFORM_TO_OPEN + "?" + "id=" + $(vButtonBiAn).data("id");
        window.location.href = vUrlToOpenPage;
      }

      /*** REGION 4 - Common funtions - Vùng khai báo hàm dùng chung trong toàn bộ chương trình*/
      //call sever by get ajax
      function callSeverByGetAjax(paramCommentIdObj) {
        //base url
        var vAPI_URL =
          gBASE_URL + "/posts/" + paramCommentIdObj.commmentId + "/comments/";
        $.ajax({
          url: vAPI_URL,
          type: "GET",
          dataType: "json",
          success: function (responseObject) {
            console.log(JSON.stringify(responseObject)); //response text
            //4 xử lý hiện thị
            loadTableCommentPostData(responseObject); // responseObject là array các posts
          },
          error: function (ajaxContext) {
            alert(ajaxContext.responseText);
          },
        });
      }

      //hàm thu thập dữ liệu
      function readData(paramCommentIdObj) {
        paramCommentIdObj.commmentId = parseInt(vInputCommentId.val().trim());
      }

      //hàm kiểm tra dữ liệu nhập vào input
      function validateCommentId(paramCommentIdObj) {
        if (isNaN(paramCommentIdObj.commmentId)) {
          alert("Comment id không được để trống, nếu bạn định tìm!");
          return false;
        }
        return true;
      }

      //hàm xóa dữ liệu table
      function resetDataTable() {
        $("#tbl-comment-posts tbody").html("");
      }

      //hiển thị dữ liệu lên table
      function loadTableCommentPostData(paramPost) {
        "use strict";
        //xóa dữ liệu table
        resetDataTable();

        //đổ data vào table
        for (var bI = 0; bI < paramPost.length; bI++) {
          //tạo row
          var bNewRow = $("<tr>").appendTo("#tbl-comment-posts tbody");
          //tạo cell
          var bArrObj = paramPost[bI];
          $("<td>").html(bArrObj.id).appendTo(bNewRow);
          $("<td>").html(bArrObj.postId).appendTo(bNewRow);
          $("<td>").html(bArrObj.email).appendTo(bNewRow);
          $("<td>").html(bArrObj.name).appendTo(bNewRow);
          $("<td>").html(bArrObj.body).appendTo(bNewRow);

          //xử lý cột Action
          var bColAction = $("<td>").addClass("btn-group").appendTo(bNewRow);
          var bNewButtonDetail = $("<button>", { html: "Chi Tiết" })
            .addClass("btn btn-info")
            .data("id", bArrObj.id)
            .appendTo(bColAction);

          //thêm event for button detail
          bNewButtonDetail.click(onBtnDetailClick);
        }
      }
    </script>
  </body>
</html>
